/*
 * 쐬: 2006/01/04
 *
 */
package org.seasar.buri.bao.test;

import java.util.Date;
import java.util.List;

import org.seasar.buri.bao.PetitionBao;
import org.seasar.buri.dao.BuriPathDao;
import org.seasar.buri.dao.BuriStateDao;
import org.seasar.buri.dto.FurnitureItemDto;
import org.seasar.buri.engine.BuriEngine;
import org.seasar.buri.engine.ParticipantProvider;
import org.seasar.buri.engine.invoker.impl.StandardBuriInvokerTest;
import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.log.Logger;

public class PetitionBaoTest extends S2TestCase {
    private static Logger logger = Logger.getLogger(StandardBuriInvokerTest.class);
    private BuriEngine buriEngine_;
    private PetitionBao petitionBao_;
    
    private BuriStateDao stateDao_;
    private BuriPathDao pathDao_;

    private final String roleSato = ",ے,\";
    private final String roleSuzuki = ",ے㗝,\";
    private final String roleTakahashi = ",W,\";
    private final String roleTanaka = "c,C,\";
    private final String roleWatanabe = "n,ʎЈ,\";
    private final String roleIto = "ɓ,ʎЈ,\";
    private final String roleYamamoto = "R{,ʎЈ,\";

    public PetitionBaoTest(String arg0) {
        super(arg0);
    }

    protected void setUp() throws Exception {
        super.setUp();
        include("org/seasar/buri/bao/test/dicon/Petition.dicon");
    }
    
    public void testFMBaoTx() {
        // {buri2.diconɏ
        ParticipantProvider provider = (ParticipantProvider)getComponent(ParticipantProvider.class);
        buriEngine_.getWorkflows().readWorkFlowFromResource("YǗ","petition.xpdl",provider);
        
        FurnitureItemDto buyItemDto = new FurnitureItemDto();
        buyItemDto.setName("T45_001");
        buyItemDto.setType("PC");
        buyItemDto.setAcquisitionTypeBuy();
        buyItemDto.setAcquisition(new Date());
        List datas;
        
        // ʎЈF\葱Jn
        logger.debug("******************************");
        logger.debug("invoke YǗ.w\");
        petitionBao_.petition(buyItemDto,roleYamamoto);
        
        // \
        logger.debug("******************************");
        logger.debug("getDataListFromPathAndUser YǗ.w\.\ "+roleYamamoto);
        datas = petitionBao_.getNowPetition(roleYamamoto);
        assertEquals(datas.size(),1);
        logger.debug(datas);
        
        // CFF҂
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleTanaka);
        datas = petitionBao_.getWaitApprove(roleTanaka);
        assertEquals(datas.size(),1);
        logger.debug(datas);
        
        logger.debug(pathDao_.getAllBuriPath());
        logger.debug(stateDao_.getAllBuriState());
        logger.debug(stateDao_.getNoProcessBuriState());
        
        // CFF
        logger.debug("******************************");
        logger.debug("invokeAction YǗ.w\ "+roleTanaka);
        petitionBao_.approve(buyItemDto,roleTanaka);
        
        logger.debug(pathDao_.getAllBuriPath());
        logger.debug(stateDao_.getAllBuriState());
        logger.debug(stateDao_.getNoProcessBuriState());
        
        // CFFς
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleTanaka);
        datas = petitionBao_.getWaitApprove(roleTanaka);
        assertEquals(datas.size(),0);

        // WFF҂
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleTakahashi);
        datas = petitionBao_.getWaitApprove(roleTakahashi);
        assertEquals(datas.size(),1);
        logger.debug(datas);
        
        // \
        logger.debug("******************************");
        logger.debug("getDataListFromPathAndUser YǗ.w\.\ "+roleYamamoto);
        datas = petitionBao_.getNowPetition(roleYamamoto);
        assertEquals(datas.size(),1);


        // WFF
        logger.debug("******************************");
        logger.debug("invokeAction YǗ.w\ "+roleTakahashi);
        petitionBao_.approve(buyItemDto,roleTakahashi);
        
        // WFFς
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleTakahashi);
        datas = petitionBao_.getWaitApprove(roleTakahashi);
        assertEquals(datas.size(),0);
        
        // ے㗝FF҂
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleSuzuki);
        datas = petitionBao_.getWaitApprove(roleSuzuki);
        assertEquals(datas.size(),1);
        logger.debug(datas);
        
        // ےFF҂
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleSato);
        datas = petitionBao_.getWaitApprove(roleSato);
        assertEquals(datas.size(),1);
        logger.debug(datas);
        
        // \
        logger.debug("******************************");
        logger.debug("getDataListFromPathAndUser YǗ.w\.\ "+roleYamamoto);
        datas = petitionBao_.getNowPetition(roleYamamoto);
        assertEquals(datas.size(),1);
        logger.debug(datas);
        
        // ےFF
        logger.debug("******************************");
        logger.debug("invokeAction YǗ.w\ "+roleSato);
        petitionBao_.approve(buyItemDto,roleSato);

        
        // ے㗝FFς
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleSuzuki);
        datas = petitionBao_.getWaitApprove(roleSuzuki);
        assertEquals(datas.size(),0);
        
        // ےFFς
        logger.debug("******************************");
        logger.debug("getDataListFromPath YǗ.w\.F҂ "+roleSato);
        datas = petitionBao_.getWaitApprove(roleSato);
        assertEquals(datas.size(),0);
        

        // \ς
        logger.debug("******************************");
        logger.debug("getDataListFromPathAndUser YǗ.w\.\ "+roleYamamoto);
        datas = petitionBao_.getNowPetition(roleYamamoto);
        assertEquals(datas.size(),0);
   

        // Fς
        logger.debug("******************************");
        logger.debug("getDataListFromPathAndUser YǗ.w\.Fς "+roleYamamoto);
        datas = petitionBao_.getEndApprove(roleYamamoto);
        assertEquals(datas.size(),1);
        logger.debug(datas);
    
        
    }

}
